<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>Task30.40</title>
</head>

<body>
    <!-- Section: Split screen -->
    <section class="">

        <div class="container-fluid px-0">
            <div class="row g-0 d-flex justify-content-center">

                <!-- First column -->
                <div class="col-lg-6 vh-100">
                    <form action="" id="formId">
                        <div class="form-group">
                            <input type="text" class="form-control" id="input-name" aria-describedby="emailHelp"
                                placeholder="Name">
                        </div>
                        <div class="form-group">                            
                            <input type="email" class="form-control" id="input-email" aria-describedby="emailHelp"
                                placeholder="Email">
                        </div>
                        <div class="form-group">
                            <textarea id="input-text" placeholder="Write something..."></textarea>
                        </div>
                        <button type="submit" class="btn btn-primary">Submit</button>
                    </form>
                </div>
                <!-- First column -->

                <!-- Second column -->
                <div class="col-lg-6 vh-100">
                    <p>CARVELI</p>
                </div>
                <!-- Second column -->

            </div>
        </div>

    </section>
    <!-- Section: Split screen -->
    <script>
        "use strict"
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_STATUS_CREATED = 201;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
        const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
        var loginForm = document.getElementById("formId");
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        loginForm.addEventListener("submit", (e) => {
            // Sử dụng preventDefault để loại bỏ hành động submit mặc định của form
            e.preventDefault();
            var vUserObject = {
                name: "",
                email: "",
                textarea: ""
            }
            getDataFromForm(vUserObject);
            var vValidate = validateData(vUserObject);
            if (vValidate == true) {
                // Gọi API
                var vXmlHttpSignUp = new XMLHttpRequest();
                callRegisterAPI(vXmlHttpSignUp, vUserObject)
                vXmlHttpSignUp.onreadystatechange =
                    function () {
                        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                            // Xử lý kết quả trả về
                            xuLyKetQuaTraVe(vXmlHttpSignUp);
                        }
                    }
            }
            // Tiếp theo thực hiện 4 bước để gọi api login
        });
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Lấy dữ liệu
        function getDataFromForm(paramUserObject) {
            var vNameElement = document.getElementById("input-name");
            var vEmailElement = document.getElementById("input-email");
            var vTextElement = document.getElementById("input-text");
            paramUserObject.name = vNameElement.value;
            paramUserObject.email = vEmailElement.value;
            paramUserObject.textarea = vTextElement.value;
        }
        // Kiểm tra dữ liệu
        function validateData(paramUserObject) {
            if (validateEmail(paramUserObject.email) == false) {
                alert("Bạn nhập sai email!");
                return false;
            }
            return true;
        }
        // Kiểm tra email
        function validateEmail(mail) {
            if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
                return (true);
            }
            return (false)
        }

        
        // Gọi API
        function callRegisterAPI(paramXMLHttpRequest, paramUserObject) {
            var vData = JSON.stringify(paramUserObject);
            paramXMLHttpRequest.open("POST", gBASE_URL, true);
            paramXMLHttpRequest.send(vData);
        }
        // Xử lý kết quả trả về
        function xuLyKetQuaTraVe(paramXMLHttpRequest) {
            var vRegisterInfo = paramXMLHttpRequest.responseText;
            console.log(vRegisterInfo);
        }
    </script>

</body>

</html>